function bench(i::Int64)
if i==0
    x = (@polyvar x[1:3])[1]
    F = [
        x[1]^3+x[2]^2+x[3]^2 - 1.0,
        x[1]^2+x[2]^3+x[3]^2 - 1.0,
        x[1]^2+x[2]^2+x[3]^3 - 1.0,
    ]
    p  = [0,1,0]
    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 1.e-2; p0 +=p
    eps0 = 1.e-1
    return F, x, p, p0, eps0
    
elseif i == 1
    #1. cbms1:
    x = (@polyvar x[1:3])[1]
    F = [
        x[1]^3 - x[2]*x[3]*1.0,
        x[2]^3 - x[1]*x[3]*1.0,
        x[3]^3 - x[1]*x[2]*1.0
    ]
    p = fill(0, 3)
    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 2.e-1; p0 +=p
    eps0 = 7.e-1
    return F, x, p, p0, eps0

elseif i == 2
    #2. cbms2:
    x = (@polyvar x[1:3])[1]
    F = [
        x[1]^3 - 3.0*x[1]^2*x[2] + 3*x[1]*x[2]^2 - x[2]^3 - x[3]^2,
        x[3]^3 - 3.0*x[3]^2*x[1] + 3*x[3]*x[1]^2 - x[1]^3 - x[2]^2,
        x[2]^3 - 3.0*x[2]^2*x[3] + 3*x[2]*x[3]^2 - x[3]^3 - x[1]^2
    ]
    p = fill(0, 3)
    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 1.e-1; p0 +=p
    eps0 = 5.e-1
    return F, x, p, p0, eps0

elseif i == 3
    #3. mth191:
    x = (@polyvar x[1:3])[1]
    F = [
        x[1]^3 + x[2]^2 + x[3]^2 - 1.0,
        x[1]^2 + x[2]^3 + x[3]^2 - 1.0,
        x[1]^2 + x[2]^2 + x[3]^3 - 1.0
    ]
    p = [0, 1, 0]
    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 8.e-2; p0 +=p
    eps0 = 2.e-1
    
    return F, x, p, p0, eps0
    
elseif i == 4  
    #4. decker2:
    x = (@polyvar x[1:2])[1]
    F = [
        x[1] + x[2]^3*1.0,
        x[1]^2*x[2] - x[2]^4
    ]
    p = [0, 0]

    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 5.e-2; p0 +=p
    eps0 = 1.e-1
    
    return F, x, p, p0, eps0
    
elseif i == 5  
    #5. Ojika2:
    x = (@polyvar x[1:3])[1]
    F = [
        x[1]^2 + x[2] + x[3] - 1.0,
        x[1] + x[2]^2 + x[3] - 1.0,
        x[1] + x[2] + x[3]^2 - 1.0
    ]
    p = [1, 0, 0]

    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 1.e-1; p0 +=p
    eps0 = 5.e-1
    
    return F, x, p, p0, eps0
    
elseif i == 6
    #6. Ojika3:
    x = (@polyvar x[1:3])[1]
    F = [
        x[1] + x[2] + x[3] - 1.0,
        2*x[1]^3 + 5*x[2]^2 - 10*x[3] + 5*x[3]^3 + 5.0,
        2*x[1] + 2*x[2] + x[3]^2 - 1.0
    ]
    p = [0, 0, 1]

    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 5.e-2; p0 +=p
    eps0 = 1.e-1
    
    return F, x, p, p0, eps0
    
elseif i == 7
    #7. KSS:
    x = (@polyvar x[1:5])[1]
    F = [
        x[1]^2-2*x[1] + x[1]+x[2]+x[3]+x[4]+x[5]-4.0,
        x[2]^2-2*x[2] + x[1]+x[2]+x[3]+x[4]+x[5]-4.0,
        x[3]^2-2*x[3] + x[1]+x[2]+x[3]+x[4]+x[5]-4.0,
        x[4]^2-2*x[4] + x[1]+x[2]+x[3]+x[4]+x[5]-4.0,
        x[5]^2-2*x[5] + x[1]+x[2]+x[3]+x[4]+x[5]-4.0
    ]
    p = [1,1,1,1,1]

    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 1.e-1; p0 +=p
    eps0 = 5.e-1
    
    return F, x, p, p0, eps0
    
elseif i == 8
    #8. Caprasse:
    x = (@polyvar x[1:4])[1]
    F = [
        -x[1]^3*x[3]+4*x[1]*x[2]^2*x[3]+4*x[1]^2*x[2]*x[4]+2*x[2]^3*x[4]+4*x[1]^2-10*x[2]^2+4*x[1]*x[3]-10*x[2]*x[4]+2,
        -x[1]*x[3]^3+4*x[2]*x[3]^2*x[4]+4*x[1]*x[3]*x[4]^2+2*x[2]*x[4]^3+4*x[1]*x[3]+4*x[3]^2-10*x[2]*x[4]-10*x[4]^2+2,
        x[2]^2*x[3]+2*x[1]*x[2]*x[4]-2*x[1]-x[3]*1.0,
        x[1]*x[4]^2+2*x[2]*x[3]*x[4]-x[1]-2*x[3]
    ]
    p = [ 2, -im*sqrt(3), 2, im*sqrt(3) ]

    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 4.e-3; p0 +=p
    eps0 = 5.e-2
    
    return F, x, p, p0, eps0

elseif i == 9
    #9. Cyclic nine:
    x = (@polyvar x[1:9])[1]
    F = [
        x[1]+x[2]+x[3]+x[4]+x[5]+x[6]+x[7]+x[8]+x[9]+0.0,
        x[1]*x[2]+x[2]*x[3]+x[3]*x[4]+x[4]*x[5]+x[5]*x[6]+x[6]*x[7]+x[7]*x[8]+x[8]*x[9]+x[9]*x[1],
        x[1]*x[2]*x[3]+x[2]*x[3]*x[4]+x[3]*x[4]*x[5]+x[4]*x[5]*x[6]+x[5]*x[6]*x[7]+x[6]*x[7]*x[8]+x[7]*x[8]*x[9]+x[8]*x[9]*x[1]+x[9]*x[1]*x[2],
        x[1]*x[2]*x[3]*x[4]+x[2]*x[3]*x[4]*x[5]+x[3]*x[4]*x[5]*x[6]+x[4]*x[5]*x[6]*x[7]+x[5]*x[6]*x[7]*x[8]+x[6]*x[7]*x[8]*x[9]+x[7]*x[8]*x[9]*x[1]+x[8]*x[9]*x[1]*x[2]+x[9]*x[1]*x[2]*x[3],
        x[1]*x[2]*x[3]*x[4]*x[5]+x[2]*x[3]*x[4]*x[5]*x[6]+x[3]*x[4]*x[5]*x[6]*x[7]+x[4]*x[5]*x[6]*x[7]*x[8]+x[5]*x[6]*x[7]*x[8]*x[9]+x[6]*x[7]*x[8]*x[9]*x[1]+x[7]*x[8]*x[9]*x[1]*x[2]+x[8]*x[9]*x[1]*x[2]*x[3]+x[9]*x[1]*x[2]*x[3]*x[4],
        x[1]*x[2]*x[3]*x[4]*x[5]*x[6]+x[2]*x[3]*x[4]*x[5]*x[6]*x[7]+x[3]*x[4]*x[5]*x[6]*x[7]*x[8]+x[4]*x[5]*x[6]*x[7]*x[8]*x[9]+x[5]*x[6]*x[7]*x[8]*x[9]*x[1]+x[6]*x[7]*x[8]*x[9]*x[1]*x[2]+x[7]*x[8]*x[9]*x[1]*x[2]*x[3]+x[8]*x[9]*x[1]*x[2]*x[3]*x[4]+x[9]*x[1]*x[2]*x[3]*x[4]*x[5],
        x[1]*x[2]*x[3]*x[4]*x[5]*x[6]*x[7]+x[2]*x[3]*x[4]*x[5]*x[6]*x[7]*x[8]+x[3]*x[4]*x[5]*x[6]*x[7]*x[8]*x[9]+x[4]*x[5]*x[6]*x[7]*x[8]*x[9]*x[1]+x[5]*x[6]*x[7]*x[8]*x[9]*x[1]*x[2]+x[6]*x[7]*x[8]*x[9]*x[1]*x[2]*x[3]+x[7]*x[8]*x[9]*x[1]*x[2]*x[3]*x[4]+x[8]*x[9]*x[1]*x[2]*x[3]*x[4]*x[5]+x[9]*x[1]*x[2]*x[3]*x[4]*x[5]*x[6],
        x[1]*x[2]*x[3]*x[4]*x[5]*x[6]*x[7]*x[8]+x[2]*x[3]*x[4]*x[5]*x[6]*x[7]*x[8]*x[9]+x[3]*x[4]*x[5]*x[6]*x[7]*x[8]*x[9]*x[1]+x[4]*x[5]*x[6]*x[7]*x[8]*x[9]*x[1]*x[2]+x[5]*x[6]*x[7]*x[8]*x[9]*x[1]*x[2]*x[3]+x[6]*x[7]*x[8]*x[9]*x[1]*x[2]*x[3]*x[4]+x[7]*x[8]*x[9]*x[1]*x[2]*x[3]*x[4]*x[5]+x[8]*x[9]*x[1]*x[2]*x[3]*x[4]*x[5]*x[6]+x[9]*x[1]*x[2]*x[3]*x[4]*x[5]*x[6]*x[7],
        1.0-x[1]*x[2]*x[3]*x[4]*x[5]*x[6]*x[7]*x[8]*x[9]
    ]
    
    z1=-1/4*(-36-16*im*15^(1/2)-4*(-163+72*im*15^(1/2))^(1/2))^(1/3)-1/4*im*3^(1/2)*(-36-16*im*15^(1/2)-4*(-163+72*im*15^(1/2))^(1/2))^(1/3)
    z0=6765/2584*z1-1/2584*z1^10
    z2=3*z0-z1
    p = [z0,z1,z2,z0,-z2,-z1,z0,-z2,-z1]
    
    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 1.e-3; p0 +=p
    eps0 = 1.e-2
    
    return F, x, p, p0, eps0
    
elseif i == 10
    #10. DZ1:
    x = (@polyvar x[1:4])[1]
    F = [
        x[1]^4 - x[2]*x[3]*x[4]*1.0,
        x[2]^4 - x[1]*x[3]*x[4]*1.0,
        x[3]^4 - x[1]*x[2]*x[4]*1.0,
        x[4]^4 - x[1]*x[2]*x[3]*1.0
    ]
    p = [0, 0, 0, 0]

    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 1.e-3; p0 +=p
    eps0 = 1.e-2
    
    return F, x, p, p0, eps0

   
elseif i == 11
    #11. DZ2:
    x = (@polyvar x[1:3])[1]
    F = [
        x[1]^4,
        x[1]^2*x[2] + x[2]^4,
        x[3] + x[3]^2 - 7*x[1]^3 - 8.0*x[1]^2
    ]
    p = [0, 0, -1]

    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 1.e-2; p0 +=p
    eps0 = 5.e-2
    
    return F, x, p, p0, eps0
    
elseif i == 12
    #12. DZ3:
    x = (@polyvar x[1:2])[1]
    F = [
        14*x[1] + 33*x[2] - 3*sqrt(5)* (x[1]^2 + 4*x[1]*x[2] + 4*x[2]^2 + 2) + sqrt(7) + x[1]^3 + 6*x[1]^2*x[2] + 12*x[1]*x[2]^2 + 8*x[2]^3,
        41*x[1] - 18*x[2] - sqrt(5) + 8*x[1]^3 - 12*x[1]^2*x[2] + 6*x[1]*x[2]^2 - x[2]^3 + 3*sqrt(7)*(4*x[1]*x[2] - 4*x[1]^2 - x[2]^2 - 2)
    ]
    #p = [1.5055, 0.36528]
    p = [ (2/5)*sqrt(7)+(1/5)*sqrt(5),-(1/5)*sqrt(7)+(2/5)*sqrt(5)];

    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 2.e-2; p0 +=p
    eps0 = 5.e-1
    
    return F, x, p, p0, eps0
return F, x, p

elseif i == 13
    #13.
    x  =(@polyvar x[1:3])[1]

    f = x[1]^6+x[2]^6+x[3]^6+(x[1]^2*x[2]^2+x[1]^2*x[2]^2+x[3]^4 -2.0*x[1]^2*x[2]^2*x[3]^2)

    F = differentiate(f,x)

    p = fill(0,3)
    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 1.e-3; p0 +=p
    eps0 = 2.e-1
    
    return F, x, p, p0, eps0

elseif i == 14
    #14.
    x  =(@polyvar x[1:3])[1]

    f = x[1]^8+x[2]^8+x[3]^8+(x[1]^4*x[2]^2+x[1]^2*x[2]^4+x[3]^6 -2.0*x[1]^2*x[2]^2*x[3]^2)

    F = differentiate(f,x)

    p = fill(0,3)
    p0 = rand(length(p)); p0 /= norm(p0); p0 *= 1.e-3; p0 +=p
    eps0 = 2.e-1
    
    return F, x, p, p0, eps0


end

end
